Loading...
Searching...
No Matches
Halide::Internal::GeneratorParamImpl< T > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorParamImpl< T >:

## Public Types

using | type = T

## Public Member Functions

| GeneratorParamImpl (const std::string &name, const T &value)
T | value () const
| operator T () const
| operator Expr () const
void | set (const std::string &new_value)
Public Member Functions inherited from Halide::Internal::GeneratorParamBase
| GeneratorParamBase (const std::string &name)
virtual | ~GeneratorParamBase ()
const std::string & | name () const
void | set (const std::string &new_value)
void | set (const char *new_value)
| GeneratorParamBase (const GeneratorParamBase &)=delete
GeneratorParamBase & | operator= (const GeneratorParamBase &)=delete
| GeneratorParamBase (GeneratorParamBase &&)=delete
GeneratorParamBase & | operator= (GeneratorParamBase &&)=delete

## Protected Member Functions

virtual void | set_impl (const T &new_value)
Protected Member Functions inherited from Halide::Internal::GeneratorParamBase
void | check_value_readable () const
void | check_value_writable () const
virtual void | set_from_string (const std::string &value_string)=0
virtual std::string | call_to_string (const std::string &v) const =0
virtual std::string | get_c_type () const =0
virtual std::string | get_type_decls () const
virtual std::string | get_default_value () const =0
virtual bool | is_synthetic_param () const
virtual bool | is_looplevel_param () const
void | fail_wrong_type (const char *type)

## Protected Attributes

T | value_

## Detailed Description

template<typename T>
class Halide::Internal::GeneratorParamImpl< T >

Definition at line 503 of file Generator.h.

## Member Typedef Documentation

## type

template<typename T>

using Halide::Internal::GeneratorParamImpl< T >::type = T

Definition at line 505 of file Generator.h.

## Constructor & Destructor Documentation

## GeneratorParamImpl()

template<typename T>

Halide::Internal::GeneratorParamImpl< T >::GeneratorParamImpl | ( | const std::string & | name,
|  | const T & | value )

inline

Definition at line 507 of file Generator.h.

References Halide::Internal::GeneratorParamBase::GeneratorParamBase(), Halide::Internal::GeneratorParamBase::name(), value(), and value_.

Referenced by Halide::Internal::GeneratorParam_Arithmetic< T >::GeneratorParam_Arithmetic(), Halide::Internal::GeneratorParam_Enum< T >::GeneratorParam_Enum(), Halide::Internal::GeneratorParam_String< T >::GeneratorParam_String(), and Halide::Internal::GeneratorParam_Target< T >::GeneratorParam_Target().

## Member Function Documentation

## value()

template<typename T>

T Halide::Internal::GeneratorParamImpl< T >::value | ( |  | ) | const

inline

Definition at line 511 of file Generator.h.

References Halide::Internal::GeneratorParamBase::check_value_readable(), and value_.

Referenced by Halide::Internal::GeneratorParam_Arithmetic< T >::GeneratorParam_Arithmetic(), Halide::Internal::GeneratorParam_Bool< T >::GeneratorParam_Bool(), Halide::Internal::GeneratorParam_Enum< T >::GeneratorParam_Enum(), Halide::Internal::GeneratorParam_String< T >::GeneratorParam_String(), Halide::Internal::GeneratorParam_Target< T >::GeneratorParam_Target(), Halide::Internal::GeneratorParam_Type< T >::GeneratorParam_Type(), GeneratorParamImpl(), Halide::Internal::GeneratorParam_Arithmetic< T >::get_default_value(), Halide::Internal::GeneratorParam_Bool< T >::get_default_value(), Halide::Internal::GeneratorParam_Enum< T >::get_default_value(), Halide::Internal::GeneratorParam_String< T >::get_default_value(), Halide::Internal::GeneratorParam_Target< T >::get_default_value(), Halide::Internal::GeneratorParam_Type< T >::get_default_value(), Halide::Internal::GeneratorParamImpl< AutoschedulerParams >::operator AutoschedulerParams(), and operator Expr().

## operator T()

template<typename T>

Halide::Internal::GeneratorParamImpl< T >::operator T | ( |  | ) | const

inline

Definition at line 516 of file Generator.h.

## operator Expr()

template<typename T>

Halide::Internal::GeneratorParamImpl< T >::operator Expr | ( |  | ) | const

inline

Definition at line 520 of file Generator.h.

References Halide::Internal::make_const(), Halide::type_of(), and value().

## set()

template<typename T>

void Halide::Internal::GeneratorParamImpl< T >::set | ( | const std::string & | new_value | ) |

inline

Definition at line 548 of file Generator.h.

References Halide::Internal::GeneratorParamBase::check_value_writable(), and value_.

Referenced by Halide::Internal::GeneratorParam_Arithmetic< T >::GeneratorParam_Arithmetic(), Halide::Internal::GeneratorParam_Arithmetic< T >::set_from_string(), Halide::Internal::GeneratorParam_Bool< T >::set_from_string(), Halide::Internal::GeneratorParam_String< T >::set_from_string(), and Halide::Internal::GeneratorParam_Target< T >::set_from_string().

## set_impl()

template<typename T>

virtual void Halide::Internal::GeneratorParamImpl< T >::set_impl | ( | const T & | new_value | ) |

inline protected virtual

Reimplemented in Halide::Internal::GeneratorParam_Arithmetic< T >.

Definition at line 554 of file Generator.h.

References Halide::Internal::GeneratorParamBase::check_value_writable(), and value_.

Referenced by Halide::Internal::GeneratorParam_Enum< T >::set(), Halide::Internal::GeneratorParam_Enum< T >::set_from_string(), and Halide::Internal::GeneratorParam_Arithmetic< T >::set_impl().

## Member Data Documentation

## value_

template<typename T>

T Halide::Internal::GeneratorParamImpl< T >::value_

protected

Definition at line 560 of file Generator.h.

Referenced by GeneratorParamImpl(), set(), set_impl(), and value().

The documentation for this class was generated from the following file:

- src/Generator.h